//Macuahuitl.cs
datablock AudioProfile(MacuahuitlDrawSound)
{
   filename    = "./swordDraw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(MacuahuitlHitSound)
{
   filename    = "./swordHit.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(MacuahuitlExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
   colors[0]     = "0.9 0.9 0.9 1";
   colors[1]     = "0.9 0.0 0.0 0.0";
   sizes[0]      = 0.75;
   sizes[1]      = 0.10;
};

datablock ParticleEmitterData(MacuahuitlExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MacuahuitlExplosionParticle";

   uiName = "Macuahuitl Hit";
};

datablock ExplosionData(MacuahuitlExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = MacuahuitlHitSound;

   particleEmitter = MacuahuitlExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "5 1 1";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("Macuahuitl",   '<bitmap:add-ons/Weapon_Macuahuitl/CI_Macuahuitl> %1',    '%2 <bitmap:add-ons/Weapon_Macuahuitl/CI_Macuahuitl> %1',0.75,1);
datablock ProjectileData(MacuahuitlProjectile)
{
   directDamage        = 45;
   directDamageType  = $DamageType::Macuahuitl;
   radiusDamageType  = $DamageType::Macuahuitl;
   explosion           = MacuahuitlExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 40;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 100;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 2.0;
   lightColor  = "3 1 1";

   uiName = "Macuahuitl Slice";
};


//////////
// item //
//////////
datablock ItemData(MacuahuitlItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Macuahuitl.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Macuahuitl";
	iconName = "./icon_Macuahuitl";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = MacuahuitlImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MacuahuitlImage)
{
   // Basic Item properties
   shapeFile = "./Macuahuitl.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0 0 0";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MacuahuitlItem;
   ammo = " ";
   projectile = MacuahuitlProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = MacuahuitlDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]			= "PrecheckFire";
	stateTransitionOnTimeout[4]		= "CheckFire";
	stateScript			= "OnStopFire";
	stateTimeoutValue[4]		= 0.4;

	stateName[5]			= "CheckFire";
	stateTransitionOnTriggerUp[5]	= "StopFire";
	stateTransitionOnTriggerDown[5]	= "Fire";

	
	stateName[6]                    = "StopFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 0.2;
	stateAllowImageChange[6]        = false;
	stateWaitForTimeout[6]		= true;
	stateSequence[6]                = "StopFire";
	stateScript[6]                  = "onStopFire";


};

function MacuahuitlImage::onPreFire(%this, %obj, %slot)
{
	%obj.playthread(2, armattack);
}

function MacuahuitlImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
}

function MacuahuitlProjectile::OnCollision(%this, %obj, %col, %fade, %pos, %normal)
{
	if(%col.getClassName() $= "Player" || %col.getClassName() $= "AIPlayer")
	{
		switch(%col.minigame)
		{
		case "0":

		default:
			%col.setdamageflash(3);
		}
	}
parent::Oncollision(%this, %obj, %col, %fade, %pos, %normal);
}